"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBotFactory = void 0;
const tslib_1 = require("tslib");
const grammy_1 = require("grammy");
const debug_1 = require("debug");
const log = (0, debug_1.default)('nestjs-grammy:create-bot-factory.util');
function createBotFactory(options) {
    var _a;
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const bot = new grammy_1.Bot(options.token, options.options);
        bot.use(...((_a = options.middlewares) !== null && _a !== void 0 ? _a : []));
        if (!bot.isInited()) {
            yield bot.init();
            log(`To optimize (for example):`);
            log(`export BOT_INFO='${JSON.stringify(bot.botInfo)}'`);
            log(`(and in forRoot():)`);
            log(`options: {botInfo: JSON.parse(process.env.BOT_INFO)},`);
        }
        log(`createBotFactory creating bot: `, options.botName);
        return bot;
    });
}
exports.createBotFactory = createBotFactory;
//# sourceMappingURL=create-bot-factory.util.js.map