"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBotDecorator = void 0;
const nestjs_grammy_constants_1 = require("../nestjs-grammy.constants");
function createBotDecorator(emitter, method) {
    return (search, ...args) => {
        return (_target, _key, descriptor) => {
            const metadata = [
                {
                    method: method || search,
                    args,
                    emitter,
                },
            ];
            const previousValue = Reflect.getMetadata(nestjs_grammy_constants_1.LISTENERS_METADATA, descriptor.value) || [];
            const value = [...previousValue, ...metadata];
            Reflect.defineMetadata(nestjs_grammy_constants_1.LISTENERS_METADATA, value, descriptor.value);
            return descriptor;
        };
    };
}
exports.createBotDecorator = createBotDecorator;
//# sourceMappingURL=create-emiiter-decorator.util.js.map