"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addPipesMetadata = exports.createGrammyPipesParamDecorator = exports.createGrammyParamDecorator = void 0;
const common_1 = require("@nestjs/common");
const shared_utils_1 = require("@nestjs/common/utils/shared.utils");
const nestjs_grammy_constants_1 = require("../nestjs-grammy.constants");
const createGrammyParamDecorator = (paramtype) => {
    return (data) => (target, key, index) => {
        const args = Reflect.getMetadata(nestjs_grammy_constants_1.PARAM_ARGS_METADATA, target.constructor, key) || {};
        Reflect.defineMetadata(nestjs_grammy_constants_1.PARAM_ARGS_METADATA, (0, common_1.assignMetadata)(args, paramtype, index, data), target.constructor, key);
    };
};
exports.createGrammyParamDecorator = createGrammyParamDecorator;
const createGrammyPipesParamDecorator = (paramtype) => (data, ...pipes) => (target, key, index) => {
    (0, exports.addPipesMetadata)(paramtype, data, pipes, target, key, index);
};
exports.createGrammyPipesParamDecorator = createGrammyPipesParamDecorator;
const addPipesMetadata = (paramtype, data, pipes, target, key, index) => {
    const args = Reflect.getMetadata(nestjs_grammy_constants_1.PARAM_ARGS_METADATA, target.constructor, key) || {};
    const hasParamData = (0, shared_utils_1.isNil)(data) || (0, shared_utils_1.isString)(data);
    const paramData = hasParamData ? data : undefined;
    const paramPipes = hasParamData ? pipes : [data, ...pipes];
    Reflect.defineMetadata(nestjs_grammy_constants_1.PARAM_ARGS_METADATA, (0, common_1.assignMetadata)(args, paramtype, index, paramData, ...paramPipes), target.constructor, key);
};
exports.addPipesMetadata = addPipesMetadata;
//# sourceMappingURL=param-decorator.util.js.map